%% RLC Lab 1


%% Import Waveform

close all
importfile('LRC_Waveform2.csv');
t = data(:,1);
v = data(:,2);
plot(t*1000,v);
xlabel('time (msec)');
ylabel('response (V)');
figure
idx = find(logical(t>-0.00005) & logical(t<0.002));
td = t(idx)*1000;
td = td +.06;
vd = v(idx);
plot(td,vd);
xlabel('time (msec)');
ylabel('response (V)');

%% Analyze Results

close all
C = 39.5e-9; % Farads
L = 49.2e-3; % Henries
w = 1/sqrt(L*C);
fprintf('LC freq (calc) %g\n',w/(2*pi));
w0 = 0.7*w; % adjust parameter
R = 200+50;
alpha = 0.5*R/L;
fprintf('xi (calculated) %g\n',alpha/w0);

wn = 2*pi*2381;
xi=sqrt(1-(wn/w0)^2);
fprintf('xi (from wn) %g\n',xi);

xi = 0.18;
alpha = xi*w0;
vf = 2;
s = roots([1 -2*xi w0^2]);
wn  = sqrt(1-xi^2)*w0;
A = [ 1 0; -alpha wn ];
b = [-vf; 0];
K = A\b;
t = linspace(0,2,501);
ts = t/1000;
y = -1+vf + (K(1)*cos(wn*ts) + K(2)*sin(wn*ts)).*exp(-alpha*ts);
fprintf('LC freq %g\n',w0/(2*pi));
fprintf('xi %g\n',xi);
fprintf('natural frequency %g\n',wn/(2*pi));
fprintf('K %g %g\n',K);
plot(td,vd,t,y,'LineWidth',2);
%plot(t,y,'LineWidth',2);
xlabel('t (msec)');
ylabel('response');


 